//--*-coding:utf-8-*--

package {
    
    import mx.controls.Alert;
    import flash.events.ContextMenuEvent;
    import flash.events.MouseEvent;
    import flash.text.TextField;
    import flash.text.TextFormat;
    import flash.text.TextFormatAlign;
    import flash.text.TextFieldAutoSize;
    import flash.ui.ContextMenu;
    import flash.ui.ContextMenuItem;
    import flash.geom.Point;
    import mx.managers.PopUpManager;
    import mx.core.UIComponent;
    import mx.binding.utils.BindingUtils;
    import mx.utils.ArrayUtil;
    
    
    public class Character extends InitiativedMovablePiece {
        
        protected var imageUrl:String = "";
        protected var size:int = 1;
        private var isHide:Boolean = false;
        private var direction:int = 0;
        private var rotation:int = 0;
        
        private var nameTextField:TextField = new TextField();
        private var thisObj:Character;
        
        public function isHit(comp:UIComponent):Boolean {
            return view.hitTestObject(comp);
        }
        
        /*
        public function updateStatusMarker(isMove:Boolean = false):void {
            var statusMarkers:Array = getMap().findExistPiecesByTypeName( StatusMarker.getTypeStatic() );
            addInfos = new Array();
            
            for(var i:int = 0 ; i < statusMarkers.length ; i++) {
                var marker:StatusMarker = statusMarkers[i] as StatusMarker;
                if( marker.getTargetId() != this.getId() ) {
                    continue;
                }
                
                if( isMove ) {
                    marker.dropedByTargetCharacter(getX(), getY());
                }
                
                addInfos.push(marker.getStatusName());
            }
            
            setToolTip();
        }
        
        private var addInfos:Array = new Array();
        
        override public function getAdditionalInfos():Array {
            return addInfos;
        }
        */
        
        override protected function droped():void {
            //var isMove:Boolean = true;
            //updateStatusMarker(isMove);
        }
        
        public static function getTypeStatic():String {
            return "characterData";
        }
        
        override public function getType():String {
            return getTypeStatic();
        }
        
        
        public static function getJsonData(name:String,
                                           imageUrl:String,
                                           size:int,
                                           isHide:Boolean,
                                           initiative:Number,
                                           info:String,
                                           direction:int,
                                           rotation:int,
                                           characterPositionX:int,
                                           characterPositionY:int):Object {
            var characterJsonData:Object = {
                "name": name,
                "imageName": imageUrl,
                "size": size,
                "isHide": isHide,
                "initiative": initiative,
                "info": info,
                "direction": direction,
                "rotation": rotation,
                
                "imgId": "0",
                "type": getTypeStatic(),
                "x": characterPositionX,
                "y": characterPositionY,
                "draggable": true
            };
            
            return characterJsonData;
        }
        
        override public function getJsonData():Object {
            var jsonData:Object = super.getJsonData();
            
            jsonData.imageName = getImageUrl();
            jsonData.size = getSize();
            jsonData.isHide = isHideMode();
            jsonData.direction = getDirection();
            jsonData.rotation = getRotation();
            
            return jsonData;
        }
        
        public function getDirection():int {
            return direction;
        }
        
        public function getRotation():int {
            return rotation;
        }
        
        public function setImageUrl(url_:String):void {
            this.imageUrl = url_;
        }
        
        public function setSize(size_:int):void {
            this.size = size_;
        }
        
        public function setHide(hide_:Boolean):void {
            if( this.isHide == hide_ ) {
                return;
            }
            
            getMapLayer().removeChild(view);
            this.isHide = hide_;
            getMapLayer().addChild(view);
            DodontoF_Main.getInstance().getInitiativeWindow().refresh();
        }
        
        public function Character(params:Object) {
            super(params);
            
            this.imageUrl = params.imageName;
            this.size = params.size;
            this.isHide = params.isHide;
            this.direction = params.direction;
            this.rotation = params.rotation;
            
            thisObj = this;
            
            setNameTag();
        }
        
        public function getImageUrl():String {
            return imageUrl;
        }
        
        public function getSize():int {
            return size;
        }
        
        override public function getWidth():int {
            return size;
        }
        
        override public function canSnapOnPositionX():Boolean {
            return true;
        }
        
        override public function isHideMode():Boolean {
            return isHide;
        }
        
        override public function getInitiative():Number {
            return super.getInitiative();
        }
        
        override public function setViewIndex(index:int):void {
            if( this.isHide ) {
                return;
            }
            super.setViewIndex(index);
        }

        
        override protected function initContextMenu():void {
            var menu:ContextMenu = new ContextMenu();
            menu.hideBuiltInItems();
            
            addMenuItem(menu, "キャラクターの変更", thisObj.getItemPopUpChangeWindow);
            addMenuItem(menu, "右回転",    thisObj.getContextMenuItemFunctionObRotateCharacter( 90), true);
            addMenuItem(menu, "180度回転", thisObj.getContextMenuItemFunctionObRotateCharacter(180));
            addMenuItem(menu, "左回転",    thisObj.getContextMenuItemFunctionObRotateCharacter(270));
            addMenuItem(menu, "キャラクターの削除", thisObj.getContextMenuItemRemoveCharacter, true);
            
            //view.contextMenu = menu;
            view.setContexMenu(menu);
        }
        
        protected function getContextMenuItemFunctionObRotateCharacter(rotationDiff:Number):Function {
            return function(event:ContextMenuEvent):void {
                var rotation:Number = thisObj.rotation;
                rotation += rotationDiff;
                rotation = ( rotation % 360 );
                thisObj.rotation = rotation;
                
                thisObj.loadViewImage();
                sender.changeCharacter( thisObj.getJsonData() );
            };
        }
        
        override public function popUpChangeWindow():void {
            try {
                Log.logging("contextmenuevent character change.");
                ChangeCharacterWindow.setCharacter(this);
                Log.logging("DodontoF.popup(ChangeCharacterWindow, true);");
                DodontoF.popup(ChangeCharacterWindow, true);
                Log.logging("contextmenuevent character changeend");
            } catch(e:Error) {
                Log.loggingExceptionDebug("Character.popUpChangeWindow()", e);
            }
        }
        
        override protected function getMapLayer():UIComponent {
            if( this.isHide ) {
                return getMap().getHideCharacterLayer();
            }
            
            return getMap().getCharacterLayer();
        }
        
        override protected function update(params:Object):void {
            Log.loggingTuning("=>Character update Begin");
            
            Log.logging("super params changed.");
            super.update(params);
            
            Log.logging("character local params changed.");
            this.imageUrl = params.imageName;
            this.size = params.size;
            setHide( params.isHide );
            //setDirection( params.direction );
            setRotation( params.rotation );
            //updateStatusMarker();
            
            loadViewImage();
            setNameTag();
            setTextFieldXPosition();
            
            Log.loggingTuning("=>analyzeChangedCharacterChanged Characteris changed End");
        }
        
        private function setNameTag():void {
            nameTextField.text = getName();
            
//             var nameTmp:String = getName();
//             var infoTmp:String = getInfo();
            
//             if( infoTmp != "" ) {
//                 nameTmp += (":" + infoTmp.match(/.*/)[0]);
//             }
            
//             nameTextField.text = nameTmp;
        }
        
        private function loadViewImage():void {
            view.loadImageWidthHeightRotation(this.name, this.imageUrl,
                                              this.size, this.size,
                                              this.rotation);
        }
        
        private function setTextFieldXPosition():void {
            var width:int = this.size * getSquareLength();
            nameTextField.x = ( (1.0 * width / 2) - (nameTextField.width / 2) );
        }
        
        override protected function initDraw(x:Number, y:Number):void {
            loadViewImage();
            move(x, y, true);
            initName();
            //drawDirection();
        }
        
        private function initName():void {
            var textHeight:int = 18;
            
            nameTextField.background = true;
            nameTextField.multiline = false;
            nameTextField.selectable = false;
            nameTextField.mouseEnabled = false;
            nameTextField.y = (textHeight * -1);
            
            nameTextField.autoSize = TextFieldAutoSize.CENTER;
            nameTextField.height = textHeight;
            setTextFieldXPosition();
            
            /*
            var format:TextFormat = new TextFormat();
            format.size=12;
            nameTextField.setTextFormat(format);
            */
            
            view.addChild(nameTextField);
        }
        
        private function setRotation(targetRotation:int):void {
            thisObj.rotation = targetRotation;
        }
        
        /*
        private var directionBaseLayer:UIComponent = null;
        private var directionLayers:Array = new Array();
        
        private function drawDirection():void {
            drawDirectionPart(  0, true);
            drawDirectionPart( 90, true);
            drawDirectionPart(180, true);
            drawDirectionPart(270, true);
            
            drawDirectionPart(  0, false);
            drawDirectionPart( 90, false);
            drawDirectionPart(180, false);
            drawDirectionPart(270, false);
        }
        
        private function setDirection(targetRotation:int):void {
            thisObj.direction = targetRotation;
            
            for(var i:int = 0 ; i< directionLayers.length ; i++) {
                var directionInfo:Object = directionLayers[i];
                var layer:UIComponent = directionInfo["layer"] as UIComponent;
                var isOn:Boolean = directionInfo["isOn"];
                var rotation:int = directionInfo["rotation"];
                
                if( targetRotation == rotation ) {
                    if( isOn ) {
                        layer.visible = true;
                    } else {
                        layer.visible = false;
                    }
                } else {
                    if( isOn ) {
                        layer.visible = false;
                    } else {
                        layer.visible = true;
                    }
                }
            }
        }
        
        private function getDirectionLayerClickEvent(targetRotation:int):Function {
            return function(event:MouseEvent):void {
                if( targetRotation == thisObj.direction ) {
                    return;
                }
                
                setDirection( targetRotation );
                DodontoF_Main.getInstance().getGuiInputSender().getSender().changeCharacter( thisObj.getJsonData() );
                //event.stopPropagation();
            };
        }
        
        private function getDirectionInfo(rotation:int, isOn:Boolean):Object {
            for(var i:int = 0 ; i < directionLayers.length ; i++) {
                var directionInfo:Object = directionLayers[i];
                if( directionInfo["rotation"] != rotation ) {
                    continue;
                }
                if( directionInfo["isOn"] != rotation ) {
                    continue;
                }
                
                return directionInfo;
            }
            return null;
        }
        
        private function createDirectionInfo(directionLayer:UIComponent,
                                             rotation:int,
                                             isOn:Boolean = false):Object {
            
            var directionInfo:Object = new Object();
            directionInfo["layer"] = directionLayer;
            directionInfo["rotation"] = rotation;
            directionInfo["isOn"] = isOn;
            
            directionLayer.addEventListener(MouseEvent.CLICK,
                                            getDirectionLayerClickEvent(rotation));
            directionLayer.alpha = 0.5;
            directionLayer.visible = ( ! isOn );
            
            return directionInfo;
            
        }
        
        private function drawDirectionMark(directionLayer:UIComponent,
                                           rotation:int,
                                           isOn:Boolean = false):void {
            var bgColor:uint = ( isOn ? 0x00FF00 : 0x999999);
            
            var borderSize:int = 2 * getSize();
            var borderColor:uint = 0xFF0000;
            
            var length:int = getSize() * getSquareLength();
            var halfLength:int = length / 2;
            
            directionLayer.x = halfLength;
            directionLayer.y = halfLength;
            
            directionLayer.graphics.clear();
            
            directionLayer.graphics.beginFill(bgColor);
            directionLayer.graphics.lineStyle(borderSize, borderColor);
            
            var markLength:int = 10 * getSize();
            var vectorNumbers:Array = getVectorNumbersForDrawTriangles(halfLength, markLength);
            //directionLayer.graphics.drawTriangles(Vector.<Number>(vectorNumbers));
            
            directionLayer.graphics.endFill();
            directionLayer.rotation = rotation;
        }
        
        private function getVectorNumbersForDrawTriangles(halfLength:int, markLength:int):Array {
            var result:Array = [
                                0,
                                (halfLength * -1), 
                                markLength,
                                (halfLength * -1 + markLength), 
                                markLength * -1,
                                (halfLength * -1 + markLength)];
            
            Log.loggingError("getVectorNumbersForDrawTriangles trianglepoints", result);
            
            return result;
        }
        
        private function drawDirectionPart(rotation:int, isOn:Boolean):void {
            var directionInfo:Object = getDirectionInfo(rotation, isOn);
            if( directionInfo != null ) {
                return;
            }
            var directionLayer:UIComponent = new UIComponent();
            drawDirectionMark(directionLayer, rotation, isOn);
            directionInfo = createDirectionInfo(directionLayer, rotation, isOn);
            directionLayers.push(directionInfo);
            
            //view.addUpperLayer(directionLayer);
            if( directionBaseLayer == null ) {
                directionBaseLayer = new UIComponent();
                BindingUtils.bindProperty(directionBaseLayer, "visible",
                                          DodontoF_Main.getInstance(), "visibleDirectionLayer");
                view.addUpperLayer(directionBaseLayer);
            }
            directionBaseLayer.addChild(directionLayer);
        }
        */
        
    }
}
