//--*-coding:utf-8-*--

package {
    
    import mx.controls.ComboBox;
    import mx.controls.Alert;
    
    public class ChatSendData {
        
        private var name:String;
        private var state:String;
        private var sendto:String;
        private var message:String = "";
        private var isDiceRollResultFlag:Boolean = false;
        
        static private var tailReturn:RegExp = /\r+$/;
        
        public function ChatSendData(message_:String,
                                     name_:String = null, 
                                     state_:String = null,
                                     sendto_:String = null):void {
            setMessage(message_);
            
            name = name_;
            state = state_;
            sendto = sendto_;
        }
        
        public function replaceMessage(before:*, after:Object):void {
            message = message.replace(before, after);
        }
        
        public function setMessage(m:String):void {
            message = m;
            replaceMessage(tailReturn, '');
        }
        
        public function getName():String {
            return getValue(name, getChatWindw().chatCharacterName.text);
        }
        
        public function getState():String {
            return getValue(state, getComboBoxText(getChatWindw().standingGraphicsStates));
        }
        
        public function getSendto():String {
            return getValue(sendto, getComboBoxText(getChatWindw().sendto));
        }
        
        private function getValue(param1:String, param2:String):String {
            if( (param1 != null) && (param1 != "") ) {
                return param1;
            }
            if( (param2 != null) && (param2 != "") ) {
                return param2;
            }
            
            return "";
        }
        
        public function getMessage():String {
            return message;
        }
        
        public function setDiceRollResult():void {
            isDiceRollResultFlag = true;
        }
        
        public function isDiceRollResult():Boolean {
            return isDiceRollResultFlag;
        }
        
        private function getChatWindw():ChatWindow {
            return ChatWindow.getInstance();
        }
        
        private function getComboBoxText(combobox:ComboBox):String {
            return Utils.getComboBoxText(combobox);
        }
        
    }
    
}
