//--*-coding:utf-8-*--
package {
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.net.URLLoader;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import mx.core.UIComponent;
    import flash.display.Sprite;
    import flash.events.KeyboardEvent;
    import flash.events.MouseEvent;
    import flash.net.FileReference;
    import flash.net.URLLoaderDataFormat;
    import flash.net.URLRequest;
    import flash.system.Capabilities;
    import flash.text.TextField;
    import flash.ui.Keyboard;
    import flash.utils.ByteArray;
    import flash.utils.clearTimeout;
    import flash.utils.setTimeout;
    import mx.collections.ArrayCollection;
    import mx.containers.Box;
    import mx.controls.Alert;
    import mx.core.Application;
    import mx.core.IFlexDisplayObject;
    import mx.events.CloseEvent;
    import flash.net.FileFilter;
    
    
	public class Replay {
        
        [Bindable]
        private var historyIndex:int = 0;
        
        
        //再生位置を変更する度に値が増える。
        //前回と値が一致する場合は再生が続行。
        //一致しない場合は再生位置が変更になったため、再生をやり直す。
        private var replaySeekIndex:int = 0;
        
        private var isPlaying:Boolean = true;
        private var isPausing:Boolean = false;
        private var timeoutId:uint = 0;
        private var sender:SharedDataSender = null;
        private var history:Array = null;
        private var replaySpeed:Number = 1;
        private var restChatMessageForReplay:Array = new Array();
        
        public function setReplaySpeed(speed:Number):void {
            replaySpeed = speed;
        }
        
        public function setSender(sender_:SharedDataSender):void {
            sender = sender_;
        }
        
        
        private var fileReferenceForSessionReplay:FileReference = null;
        private var loadCaller:Function = null;
        
        public function replayFromSessionRecord():void {
            loadReplayData( playReplayFromData );
        }
        
        public function loadReplayData(call:Function):void {
            loadCaller = call;
            
            fileReferenceForSessionReplay = new FileReference();
            fileReferenceForSessionReplay.addEventListener(Event.SELECT, replayFromSessionRecordOnSelect);
            
            var filters:Array = new Array();
            filters.push(new FileFilter("プレイ録画データ(*.rec)","*.rec"));
            
            fileReferenceForSessionReplay.browse(filters);
        }
        
        public function replayFromSessionRecordOnSelect(e:Event):void {
            fileReferenceForSessionReplay.addEventListener(Event.COMPLETE,
                                                           replayFromSessionRecordOnComplete);
            fileReferenceForSessionReplay.load();
        }
        
        private function replayFromSessionRecordOnComplete(e:Event):void {
            var data:ByteArray = fileReferenceForSessionReplay.data as ByteArray;
            var fileName:String = fileReferenceForSessionReplay.name;
            loadCaller(data, fileName);
        }
        
        public function playReplayFromData(data:ByteArray, fileName:String):void {
            var dataString:String = data.toString();
            playReplayFromDataString(dataString);
        }
        
        private function init():void {
            historyIndex = 0;
            restChatMessageForReplay = new Array();
            setSlider();
            DodontoF_Main.getInstance().getChatWindow().setSoundState(false);
        }
        
        public function setSlider():void {
            DodontoF_Main.getInstance().getDodontoF().replaySeekSlider.value = historyIndex;
        }
        
        public function playReplayFromDataString(dataString:String):void {
            Log.loggingError("録画データロード中……");
            
            history = SharedDataReceiver.getJsonDataFromString(dataString) as Array;
            DodontoF_Main.getInstance().getDodontoF().replaySeekSlider.maximum = history.length;
            
            init();
            
            Log.loggingError("リプレイ録画を再生します。");
            
            historyIndex = DodontoF_Main.getInstance().getReplayStartPosition() - 1;
            replaySeekIndex = -1;
            beginChangeReplayPoint();
        }
        
        public function addRestChatMessageForReplay(messageData:Object):void {
            restChatMessageForReplay.push(messageData);
        }
        
        private function getPlayingState():Boolean {
            return isPlaying;
        }
        private function setPlayingState(b:Boolean):void {
            isPlaying = b;
            
            if( isPlaying ) {
                DodontoF_Main.getInstance().getDodontoF().setPauseIcon();
            } else {
                DodontoF_Main.getInstance().getDodontoF().setPlayIcon();
            }
        }
        
        private var characterSleepTime:int = 0.5 * 1000;
        
        private function getChatSleepTime(length:int):Number {
            return (0.7 + (length * 0.07)) * 1000;
        }
        
        private function getChatSleepTimeFromMessageData(messageData:Object):Number {
            var chatMessage:String = messageData[1];
            return getChatSleepTime(chatMessage.length);
        }
        
        private function replayHistory(currentReplaySeekIndex:int):void {
            
            if( isPausing ) {
                setPlayingState( false );
                isPausing = false;
                restChatMessageForReplay = new Array();
                return;
            }
            
            if( currentReplaySeekIndex != replaySeekIndex ) {
                beginChangeReplayPoint();
                return;
            }
            
            if( (history.length == historyIndex) && (restChatMessageForReplay.length == 0) ) {
                Log.loggingError("リプレイ再生を終了します。");
                setPlayingState( false );
                return;
            }
            
            var sleepTime:int = 0;
            
            if( restChatMessageForReplay.length > 0 ) {
                sleepTime = printRestChatMessage();
            } else {
                var jsonData:Object = history[historyIndex];
                historyIndex++;
                setSlider();
                
                sleepTime = analyzeForReplay(jsonData);
            }
            sleepTime /= replaySpeed;
            
            timeoutId = setTimeout(replayHistory, sleepTime, currentReplaySeekIndex);
        }
        
        public function stopTimer():void {
            if( timeoutId == 0 ) {
                return;
            }
            
            clearTimeout(timeoutId);
            timeoutId = 0;
        }
        
        public function changeReplayPoint(point:int):void {
            DodontoF_Main.getInstance().getDodontoF().replaySeekSlider.enabled = false;
            
            replaySeekIndex++;
            
            historyIndex = point;
            
            //再生が停止している場合には、ここで再生を再開する
            if( ! getPlayingState() ) {
                isPausing = false;
                setPlayingState( true );
                beginChangeReplayPoint();
            }
        }
        
        public function beginChangeReplayPoint():void {
            DodontoF_Main.getInstance().clearForReplay();
            
            var jsonData:Object = new Object();
            
            for(var i:int = 0 ; i < historyIndex ; i++) {
                var tmp_jsonData:Object = history[i];
                
                for(var key:String in tmp_jsonData) {
                    if( tmp_jsonData[key] != null ) {
                        jsonData[key] = tmp_jsonData[key];
                    }
                }
            }
            
            analyzeForReplay(jsonData);
            replayHistory(replaySeekIndex)
            DodontoF_Main.getInstance().getDodontoF().replaySeekSlider.enabled = true;
        }
        
        public function pauseAndPlay():void {
            DodontoF_Main.getInstance().getDodontoF().setPauseAndPlayIconDisable();
            
            //再生中の場合
            if( getPlayingState() ) {
                isPausing = true;
                return;
            }
            
            //停止中の場合
            setPlayingState( true );
            beginChangeReplayPoint();
        }
        
        private function printRestChatMessage():int {
            
            var messageData:Object = restChatMessageForReplay.shift();
            
            DodontoF_Main.getInstance().getChatWindow().clearChatMessageLog();
            DodontoF_Main.getInstance().getChatWindow()
                .addMessageToChatLog(messageData[0],
                                     messageData[1],
                                     messageData[2],
                                     messageData[3],
                                     messageData[4],
                                     true);
            
            return getChatSleepTimeFromMessageData(messageData);
        }
        
        private function analyzeForReplay(jsonData:Object):int {
            var reciever:SharedDataReceiver = sender.getReciever();
            var isValidResponse:Boolean = reciever.analyzeRefreshResponseCatchedCallByJsonData(jsonData);
            
            if( isValidResponse ) {
                if( jsonData.chatMessageDataLog != null ) {
                    var messageData:Object = restChatMessageForReplay[ restChatMessageForReplay.length - 1 ];
                    return getChatSleepTimeFromMessageData(messageData);
                }
                if( jsonData.characters != null) {
                    return characterSleepTime;
                }
            }
            
            return 0;
        }
        
	}
}
