//--*-coding:utf-8-*--

package {
    
    import com.adobe.serialization.json.JSON;
    import flash.events.Event;
    import flash.events.IOErrorEvent;
    import flash.events.ProgressEvent;
    import flash.net.FileFilter;
    import flash.net.FileReference;
    import flash.net.sendToURL;
    import flash.net.URLLoader;
    import flash.net.URLLoaderDataFormat;
    import flash.net.URLRequest;
    import flash.net.URLRequestMethod;
    import flash.net.URLVariables;
    import flash.utils.*;
    import mx.controls.Alert;
    import com.nextgenapp.wave.gadget.*;
    import mx.utils.StringUtil;
    
    public class SharedDataSenderForGoogleWave implements SharedDataSender {
        
        private var loadParams:Object = null;
        
        private var uniqueId:String = "";
        
        private var refreshTimeoutPadding:int = 10;
        
        private var thisObj:SharedDataSenderForGoogleWave = null;
        private var map:Map = null;
        protected var saveDataDirIndex:int = 0;
        
        private var lastUpdateTimes:Object = getInitLastUpdateTimes();
        private var receiver:SharedDataReceiver = newReceiverForInitialize();
        
        private var wave:Wave = null;
        
        public function SharedDataSenderForGoogleWave() {
            thisObj = this;
            receiver.setSender(this);
            initWave();
        }
        
        private function initWave():void {
            wave = new Wave();
            initDefaultSaveData();
        }
        
        public function setUniqueId(uniqueId_:String):void {
            this.uniqueId = uniqueId_;
        }
        
        public function getUniqueId():String {
            return this.uniqueId;
        }
        
        public function isSampleMode():Boolean {
            return DodontoF_Main.getInstance().isSampleMode();
        }
        
        public function setRefreshTimeout(timeout:int):void {
        }
        
        public function setMap(map_:Map):void {
            map = map_;
            receiver.setMap(map);
        }
        
        public function getMap():Map {
            return map;
        }
        
        public function getReciever():SharedDataReceiver {
            return receiver;
        }
        
        public function getRoomNumber():int {
            return saveDataDirIndex;
        }
        
        public function setSaveDataDirIndex(roomNumber:int):void {
            saveDataDirIndex = roomNumber;
        }
        
        public function checkRoomStatus(roomNumber:int, resultFunction:Function):void {
            var jsonData:Object = {
                "isRoomExist" : true,
                "roomName" : "GoogleWave",
                "roomNumber" : roomNumber,
                "isPasswordLocked" : false,
                "isMentenanceModeOn" : false
            }
            resultFunction(jsonData);
        }
        
        public function loginPassword(roomNumber:int, password:String, resultFunction:Function):void {
        }
        
        private var fileReferenceForSaveDownload:FileReference;
        
        private function getSaveTargetTypes(saveFileName:String):Array {
            var regExp:RegExp = new RegExp("\." + mapSaveFileExtension + "$");
            var regResult:Object = regExp.exec(saveFileName);
            if( regResult != null ) {
                return ['mapData', 'characters', 'graveyard'];
            }
            
            var types:Array = new Array();
            for(var key:String in defaultSaveData) {
                types.push(key);
            }
            return types;
        }
        
        public function saveFileDownload(saveFileName:String, resultFunction:Function):void {
            var types:Array = getSaveTargetTypes(saveFileName);
            var saveText:String = getSaveText(types);
            
            fileReferenceForSaveDownload = new FileReference();
            fileReferenceForSaveDownload.addEventListener(Event.COMPLETE,
                                                      function(event:Event):void {
                                                          resultFunction();
                                                      });
            fileReferenceForSaveDownload.save(saveText, saveFileName);
        }
        
        private function getSaveText(types:Array):String {
            var saveDataAll:Object = new Object();
            
            for(var i:int = 0 ; i < types.length ; i++) {
                var key:String = types[i];
                var data:Object = getSaveData(key);
                saveDataAll[key] = data;
            }
            
            return Utils.getJsonString( saveDataAll );
        }
        
        private var saveFileExtension:String = "sav";
        private var mapSaveFileExtension:String = "msv";
        
        public function save(resultFunction:Function):void {
            var saveFileName:String = getNewSaveFileName(saveFileExtension);
            var jsonData:Object = {"saveFileName" : saveFileName};
            resultFunction(jsonData);
        }
        
        public function saveMap(resultFunction:Function):void {
            var saveFileName:String = getNewSaveFileName(mapSaveFileExtension);
            var jsonData:Object = {"saveFileName" : saveFileName};
            resultFunction(jsonData);
        }
        
        private function getNewSaveFileName(extension:String):String {
            var date:Date = new Date();
            return StringUtil.substitute("DodontoF_{0}_{1}{2}_{3}{4}{5}.{6}", 
                                         date.fullYear,
                                         date.month,
                                         date.date,
                                         date.hours,
                                         date.minutes,
                                         date.seconds,
                                         extension);
        }

              
        public function load(params:Object):void {
            loadSelectFile(params, saveFileExtension);
        }
        
        public function loadMap(params:Object):void {
            loadSelectFile(params, mapSaveFileExtension);
        }
        
        private var fileReferenceForUpload:FileReference = null;
        
        private function loadSelectFile(params:Object, extension:String):void {
            loadParams = params;
            
            fileReferenceForUpload  = new FileReference();
            fileReferenceForUpload.addEventListener(Event.SELECT, fileSelectHandlerForLoad);
            
            var filters:Array = new Array();
            filters.push(new FileFilter("セーブデータ(*." + extension + ")", "*." + extension));
            
            fileReferenceForUpload.browse(filters);
        }
        
        private function fileSelectHandlerForLoad(event:Event):void {
            var fileReference:FileReference = event.currentTarget as FileReference;
            fileReference.addEventListener(Event.COMPLETE, fileCompleateHandlerForLoad);
            fileReference.load();
        }
        
        private function fileCompleateHandlerForLoad(event:Event):void {
            var fileReference:FileReference = event.currentTarget as FileReference;
            
            var data:ByteArray = fileReference.data as ByteArray;
            loadToSaveData(data);
        }
        
        public function loadToSaveData(data:ByteArray):void {
            var dataString:String = data.toString();
            var saveData:Object = Utils.getJsonDataFromString(dataString);
            
            for(var key:String in saveData) {
                setSaveData(key, saveData[key]);
            }
        }
        
        public function uploadImageFile(fileReferenceForImageUpload:FileReference,
                                        params:Object):void {
            sendFileUpload(fileReferenceForImageUpload, "uploadImageFile", params);
        }
        
        public function uploadImageData(params:Object, resultFunction:Function, errorFunction:Function):void {
        }
        
        public function sendFileUpload(fileReferenceForLocal:FileReference,
                                       commandName:String,
                                       params:Object = null):void {
            var request:URLRequest = new URLRequest( Config.getInstance().getDodontoFServerCgiUrl() );
            
            request.method = URLRequestMethod.POST;
            var jsonData:Object = {
                "Command" : commandName,
                "saveDataDirIndex" : this.saveDataDirIndex
            };
            
            if( isSampleMode() ) {
                jsonData.isSampleMode = true;
            }
            
            if( params != null ) {
                for(var key:String in params) {
                    jsonData[key] = params[key];
                }
            }
            
            var jsonParams:String = getEncodedJsonString(jsonData);
            Log.loggingTuning("load jsonParams", jsonParams);
            
            /*
              var variables:URLVariables =
              new URLVariables("__jsonDataForFileUploader__=" + jsonParams);
              request.data = variables;
            */
            var variables:URLVariables = new URLVariables();
            variables.__jsonDataForFileUploader__ = jsonParams;
            
            request.data = variables;
            Log.loggingTuning("fileReferenceForLocal.upload(request) calling...");
            
            fileReferenceForLocal.upload(request);
            Log.loggingTuning("fileReferenceForLocal.upload(request) called.");
        }
        
        public function checkLastUpdateTimes(type:String, jsonLastUpdateTimes:Object):Boolean {
            Log.logging("setLastUpdateTimes called");
            Log.logging("type", type);
            
            if( isReplayMode() ) {
                return true;
            }
            
            var timeValue:Number = jsonLastUpdateTimes[type];
            Log.logging("timeValue", timeValue);
            
            if( this.lastUpdateTimes[type] > timeValue ) {
                return false;
            }
            
            this.lastUpdateTimes[type] = timeValue;
            return true;
        }
        
        public function resurrectCharacter(resurrectCharacterId:String):void {
            var characters:Array = getSaveData("characters") as Array;
            var graveyard:Array = getSaveData("graveyard") as Array;
            
            var index:int = -1;
            var characterData:Object = null;
            for(var i:int = 0 ; i < graveyard.length ; i++) {
                characterData = graveyard[i];
                if( characterData['imgId'] == resurrectCharacterId ) {
                    index = i;
                }
            }
            
            if( index == -1 ) {
                return;
            }
            
            graveyard.splice(index, 1); 
            characters.push(characterData);
            
            setSaveData("characters", characters);
            setSaveData("graveyard", graveyard);
        }
        
        public function sendRoundTimeData(round:int, initiative:Number, counterNames:Array):void {
            var roundTimeData:Object = {"round": round,
                                        "initiative": initiative,
                                        "counterNames": counterNames};
            setSaveData("roundTimeData", roundTimeData);
        }
        
        
        public function startRefresh():void {
            refresh();
            wave.setStateCallback( refresh );
        }
        
        public function clearRetry():Boolean {
            return false;
        }
        
        private var isStopRefreshOn:Boolean = false;
        
        public function stopRefresh():void {
            isStopRefreshOn = true;
        }
        
        public function isStopRefresh():Boolean {
            return isStopRefreshOn;
        }
        
        public function logout():void {
            stopRefresh();
        }
        
        
        /////////////////////////////////////////
        
        
        private function getSaveDataString(type:String):String {
            
            var state:WaveState = wave.getState();
            return state.getStringValue( type );
        }
        
        private function getSaveData(type:String):Object {
            Log.logging("getSaveData begin. type", type);
            
            var saveDataString:String = getSaveDataString(type);
            
            if( saveDataString != null ) {
                Log.logging(type, saveDataString);
                return Utils.getJsonDataFromString(saveDataString);
            }
            
            Log.logging(type + " is NULL so get default" );
            
            var saveData:Object = defaultSaveData[type];
            if( saveData == null ) {
                Alert.show("type : " + type + " is unknown saveData type.");
            }
            
            Log.logging("getSaveData end.");
            
            return getClone(saveData);
        }
        
        private function setSaveDataList(dataList:Array):void {
            for(var i:int = 0 ; i < dataList.length ; i++) {
                var data:Object = dataList[i];
                var type:String = data[0];
                var obj:Object = data[1];
                setSaveData(type, obj, false);
            }
        }
        
        private function setSaveData(type:String, obj:Object, isRefresh:Boolean = true):void {
            var objString:String = Utils.getJsonString(obj);
            Log.logging("setSaveData objString", objString);
            
            
            Log.logging("setSaveData pass1");
            var delta:Object = new Object();
            delta[type] = objString;
            
            Log.logging("setSaveData pass2");
            var state:WaveState = wave.getState();
            state.submitDelta( delta );
            Log.logging("setSaveData pass3");
        }
        
        /*
          private function testWave():void {
          Alert.show("in wave container=" + wave.isInWaveContainer() + ".  time=" + wave.getTime());
          var viewer:WaveParticipant = wave.getViewer();
          if( viewer != null ) {
          Alert.show("viewer: id=" + viewer.id + " displayName=" + viewer.displayName + ".   thumbnailUrl=" + viewer.thumbnailUrl);
          }
          }
        */
        /////////////////////////////////////////
        
        private var refreshIndex:int = 0;
        
        private var defaultSaveData:Object = new Object();
        
        private function initDefaultSaveData():void {
            defaultSaveData = {
                "lastUpdateTimes" : this.lastUpdateTimes,
                "refreshIndex" : this.refreshIndex,
                "loginUserInfo" : [],
                
                "characters" :
                [{"name":"sample","imgId":"character_1260575421.171_1","size":1,"x":8,"y":4,"draggable":true,"isHide":false,"info":"","type":"characterData","imageName":"image\/defaultImageSet\/chara01_a5_24_2.png","direction":0,"rotation":0,"initiative":0}],
                
                "graveyard" :
                [],
                
                "roundTimeData" :
                {"counterNames":["HP","MP"],"round":1,"initiative":0},
                
                "chatMessageDataLog" :
                [[0,{"senderName":"どどんとふ","uniqueId":"1260575380.062","messageIndex":-1,"color":"00AA00","message":"「ななしさん」がログインしました。"}]],
                
                "effects":
                [{"effectId":"1228488734.998","mx_internal_uid":"EF58BC99-5BC7-2809-9D6A-113F92FF3F81","displaySeconds":0.0,"message":"驚愕","source":".\/movie\/shout.flv"},{"effectId":"1228623756.228","mx_internal_uid":"8DE523DC-0945-543A-0167-01934FCDC887","height":0.0,"displaySeconds":4.0,"message":"眼鏡さん","source":".\/image\/stand\/glass_smile.png","width":0.0},{"name":"スポーツ娘","effectId":"1228825137.001","type":"standingGraphicInfos","source":"image\/stand\/sports_normal.png","state":"通常"},{"name":"スポーツ娘","effectId":"1228825151.579","mx_internal_uid":"61763FB4-46A9-4EE4-589B-212E023F5699","type":"standingGraphicInfos","source":"image\/stand\/sports_angry.png","state":"怒り"}],
                
                "mapData" :
                {"yMax":20,"mapMarks":[],"imageSource":"image\/defaultImageSet\/\/feeld001.gif","mapType":"imageGraphic","xMax":20,"gridColor":0}
            }
        }
        
        public function refresh(obj:Object = null):void {
            if( isStopRefreshOn ) {
                return;
            }
            
            var jsonData:Object = new Object();
            var types:Array = ["characters", "graveyard", "roundTimeData", "chatMessageDataLog", "effects",
                               "mapData", "lastUpdateTimes", "refreshIndex", "loginUserInfo"];
            
            for(var i:int = 0 ; i < types.length ; i++) {
                var type:String = types[i];
                jsonData[type] = getSaveData(type);
            }
            
            var isValidResponse:Boolean = receiver.analyzeRefreshResponseCatchedCallByJsonData(jsonData);
        }
        
        private function getUserName():String {
            var userName:String = "";
            
            try {
                userName = ChatWindow.getInstance().chatCharacterName.text;
            } catch (error:Error) {
            }
            
            return userName;
        }
        
        private function isReplayMode():Boolean {
            return DodontoF_Main.getInstance().isReplayMode();
        }
        
        public function clearLastRefreshIndex(index:int):Boolean {
            if( isReplayMode() ) {
                return true;
            }
            
            if( this.refreshIndex != index ) {
                return false;
            }
            
            return true;
        }
        
        public function changeMap(mapImageUrl:String, 
                                  mapWidth:int,
                                  mapHeight:int, 
                                  gridColor:uint,
                                  mapMarks:Array):void {
            var mapData:Object = {
                "mapType": "imageGraphic",
                "imageSource": mapImageUrl,
                "xMax": mapWidth,
                "yMax": mapHeight,
                "gridColor": gridColor,
                "mapMarks": mapMarks};
            
            changeMapSaveData(mapData);
        }
        
        private function changeMapSaveData(mapData:Object):void {
            setSaveData('mapData', mapData);
        }
        
        public function deleteImage(imageUrlList:Array,
                                    resultFunction:Function):void {
            var jsonData:Object = {
                "imageUrlList": imageUrlList
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("deleteImage", [["imageData", jsonParams]]);
            this.sendCommandData_ToServer(params, resultFunction);
        }
        
        public function addCharacter(characterJsonData:Object, keyName:String = "name"):void {
            var result:Object = addCharacterData( [characterJsonData], keyName );
            printAddFailedCharacterName(result);
        }
        
        private function addCharacterData(characterDataList:Array, keyName:String):Object {
            var addFailedCharacterNames:Array = new Array;
            var characters:Array = getSaveData("characters") as Array;
            
            for(var i:int = 0 ; i < characterDataList.length ; i++) {
                var characterData:Object = characterDataList[i];
                addCharacterInOwnMap(characterData, keyName);
                
                characterData['imgId'] = createCharacterImgId();
                
                var failedName:String = isAlreadyExistCharacter(characters, characterData);
                if( failedName != null ) {
                    addFailedCharacterNames.push(failedName);
                    continue;
                }
                
                characters.push(characterData);
            }
            
            setSaveData("characters", characters);
            
            return {"addFailedCharacterNames" : addFailedCharacterNames};
        }
        
        private function getClone(obj:Object):Object {
            var buffer:ByteArray = new ByteArray();
            buffer.writeObject(obj);
            buffer.position = 0;
            var newObj:Object = buffer.readObject();
            return newObj;
        }
        
        private function addCharacterInOwnMap(characterData:Object, keyName:String):void {
            var newCharacterData:Object = getClone(characterData);
            
            newCharacterData[keyName] = "(作成中・・・)" + newCharacterData[keyName];
            receiver.addCharacterInOwnMap(newCharacterData);
        }
        
        private function isAlreadyExistCharacter(characters:Array, characterData:Object):String {
            if( characterData['name'] == null ) {
                return null;
            }
            if( characterData['name'] == "" ) {
                return null;
            }
            
            for(var i:int = 0 ; i < characters.length ; i++) { 
                var character:Object = characters[i];
                
                if( (character['imgId'] == characterData['imgId']) ||
                    (character['name'] == characterData['name']) ) {
                    
                    return characterData['name']
                        }
            }
            
            return null;
        }
        
        public function printAddFailedCharacterName(event:Object):void {
            var jsonData:Object = SharedDataReceiver.getJsonDataFromResultEvent(event);
            var addFailedCharacterNames:Array = jsonData.addFailedCharacterNames;
            if( addFailedCharacterNames.length == 0 ) {
                return;
            }
            var message:String = "「" + addFailedCharacterNames.join("」「") + "」という名前のキャラクターはすでに存在するため追加に失敗しました。";
            
            DodontoF_Main.getInstance().getChatWindow().sendSystemMessage(message, false);
        }
        
        private var imgIdIndex:int = 0;
        
        private function createCharacterImgId(prefix:String = "character_"):String {
            imgIdIndex++;
            return (prefix + new Date().valueOf() + "_" + imgIdIndex);
        }
        
        
        public function moveCharacter(movablePiece:MovablePiece, x:Number, y:Number):void {
            //var moveData:String = getEncodedJsonString( {"imgId": movablePiece.getId(), "x": x, "y": y});
            
            var characters:Array = getSaveData("characters") as Array;
            
            for(var i:int = 0 ; i < characters.length ; i++) {
                var characterData:Object = characters[i];
                if( characterData['imgId'] == movablePiece.getId() ) {
                    characterData['x'] = x;
                    characterData['y'] = y;
                    break;
                }
            }
            
            setSaveData("characters", characters);
        }
        
        public function removeCharacter(piece:Piece):void {
            removeCharacters( [piece] );
        }
        
        public function removeInvalidCharacter(characterId:String):void {
            removeCharacterByRemoveInfos( [getRemoveInfo(characterId, true)] );
        }
        
        static public function getRemoveInfo(characterId:String, isGotoGraveyard:Boolean):Object {
            var removeInfo:Object = {"imgId" : characterId,
                                     "isGotoGraveyard" : isGotoGraveyard};
            return removeInfo;
        }
        
        public function removeCharacters(pieces:Array):void {
            var infos:Array = [];
            
            for(var i:int = 0 ; i < pieces.length ; i++) {
                var piece:Piece = pieces[i];
                infos.push( getRemoveInfo(piece.getId(), piece.isGotoGraveyard()) );
            }
            
            removeCharacterByRemoveInfos( infos );
        }
        
        private function removeCharacterByRemoveInfos(removeInfos:Array):void {
            var characters:Array = getSaveData("characters") as Array;
            var graveyard:Array = getSaveData("graveyard") as Array;
            
            for(var i:int = 0 ; i < removeInfos.length ; i++) {
                var removeCharacterData:Object = removeInfos[i];
                var removeCharacterId:String = removeCharacterData['imgId'];
                var isGotoGraveyard:Boolean = removeCharacterData['isGotoGraveyard'];
                
                removeTargetImgIdCharacter(characters, removeCharacterId, isGotoGraveyard, graveyard);
            }
            
            setSaveDataList([["characters", characters],
                             ["graveyard", graveyard]]);
        }
        
        
        public function removeTargetImgIdCharacter(characters:Array, imgId:String, isGotoGraveyard:Boolean, graveyard:Array):void {
            var index:int = -1;
            var character:Object = null;
            
            for(var i:int = 0 ; i < characters.length ; i++) {
                character = characters[i];
                if( character["imgId"] == imgId ) {
                    index = i;
                    break;
                }
            }
            
            if( index == -1 ) {
                return;
            }
            
            if( isGotoGraveyard ) {
                moveCharacterToGraveyard(character, graveyard)
            } else {
                characters.splice(index, 1); 
            }
        }
        
        private function moveCharacterToGraveyard(character:Object, graveyard:Array):void {
            graveyard.push(character);
            
            while(graveyard.length > Config.getInstance().getGraveyardLimit() ) {
                graveyard.shift();
            }
        }
        
        public function changeCharacter(characterData:Object):void {
            var characters:Array = getSaveData("characters") as Array;
            
            for(var i:int = 0 ; i < characters.length ; i++) {
                var character:Object = characters[i];
                if(character['imgId'] == characterData['imgId']) {
                    characters[i] = characterData;
                }
            }
            
            setSaveData("characters", characters);
        }
        
        public function sendDiceBotChatMessage(chatSendData:ChatSendData,
                                               randomSeed:int, gameType:String, callBack:Function):void {
            var request:URLRequest = new URLRequest();
            request.url = Config.getInstance().getDiceBotCgiUrl();
            request.method = URLRequestMethod.POST;
            var variables:URLVariables = new URLVariables();
            variables.name = chatSendData.getName();
            variables.state = chatSendData.getState();
            variables.sendto = chatSendData.getSendto();
            variables.message = chatSendData.getMessage();
            variables.gameType = gameType;
            variables.randomSeed = randomSeed;
            request.data = variables;
            
            var loader:URLLoader = new URLLoader();
            loader.addEventListener(Event.COMPLETE, callBack);
            loader.load(request);
        }
        
        
        public function sendChatMessage(chatCharacterName:String, message:String, color:String, messageIndex:int, sendto:String):void {
            var chatData:Object = {
                "senderName": chatCharacterName,
                "message" : message,
                "color" : color,
                "uniqueId" : uniqueId,
                "messageIndex" : messageIndex
            };
            
            if( sendto != null ) {
                chatData.sendto = sendto;
            }
            
            var chatMessageDataLog:Array = getSaveData('chatMessageDataLog') as Array;
            deleteOldChatMessageData(chatMessageDataLog);
            var now:Number = new Date().valueOf();
            var chatMessageData:Array = [now, chatData];
            
            chatMessageDataLog.push(chatMessageData);
            
            chatMessageDataLog.sort(function(a:Array, b:Array):Number {
                    var valueA:Number = a[0];
                    var valueB:Number = b[0];
                    
                    if( valueA > valueB ) {
                        return 1;
                    }
                    
                    if( valueA < valueB ) {
                        return -1;
                    }
                    
                    return 0;
                });
            
            setSaveData('chatMessageDataLog', chatMessageDataLog);
        }
        
        //FIXME
        private function deleteOldChatMessageData(chatMessageDataLog:Array):void {
        }
        
        public function sendChatMessageMany(chatCharacterName:String, message:String, color:String):void {
        }
        
        private function sendCommandData(paramsString:String,
                                         callBack:Function = null,
                                         isRefresh:Boolean = false):void {
            Alert.show("command : " + paramsString );
        }
        
        private function sendCommandData_ToServer(paramsString:String,
                                                  callBack:Function = null,
                                                  isRefresh:Boolean = false):void {
            Log.loggingTuning("==>Begin sendCommandData_ToServer");
            Log.logging("sendCommandData_ToServer paramsString : ", paramsString);
            
            try {
                sendCommandDataCatched(paramsString,
                                       callBack,
                                       isRefresh);
            } catch( e:Error ) {
                Log.loggingException("SharedDataSender.sendCommandData_ToServer()", e);
            }
            Log.loggingTuning("==>End sendCommandData_ToServer");
        }
        
        public function createPlayRoom(playRoomName:String,
                                       playRoomPassword:String,
                                       playRoomIndex:int,
                                       resultFunction:Function):void {
            Alert.show("createPlayRoom is NOT supported.")
        }

        public function changePlayRoom(playRoomName:String,
                                       playRoomPassword:String,
                                       playRoomIndex:int,
                                       resultFunction:Function):void {
            Alert.show("changePlayRoom is NOT supported.");
        }
        
        public function requestImageList(resultFunction:Function):void {
            var jsonData:Object = {
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("getImageList", [["imageData", jsonParams]]);
            this.sendCommandData_ToServer(params, resultFunction);
        }
        
        public function requestImageTagInfosAndImageList(resultFunction:Function):void {
            var params:String = this.getParamString("getImageTagsAndImageList", []);
            this.sendCommandData_ToServer(params, resultFunction);
        }
        
        public function requestGraveyard(resultFunction:Function):void {
            var graveyard:Array = getSaveData("graveyard") as Array;
            
            var result:Array = graveyard.concat();
            result.reverse();
            
            resultFunction(result);
        }
        
        private function getUniqueIdOnWave():String {
            var viewer:WaveParticipant = wave.getViewer();
            if( viewer != null ) {
                return wave.getViewer().id;
            }
            
            return "" + (new Date().valueOf());
        }
        
        public function requestLoginInfo(resultFunction:Function):void {
            var result:Object = {
                "playRoomStates" : [{"loginUsers":[],"passwordLockState":"--","lastUpdateTime":"---","loginUserCount":0,"index":"0","playRoomName":"samplePlayRoom"}],
                "loginMessage" : "loginMessage",
                "autoLoginRoom" : 0,
                "cardInfos" : [{"title":"TRUMP","type":"trump_jorker3"},{"title":"TORG","type":"torg"}],
                "isDiceBotOn" : true,
                "uniqueId" : getUniqueIdOnWave(),
                "refreshTimeout" : 10,
                "version" : "Ver.1.25.00.01(2010/04/04)",
                "playRoomMaxNumber" : 1
            };
            
            resultFunction(result);
        }

        public function uploadImageUrl(imageUrl:String, tagInfo:Object, resultFunction:Function):void {
            var jsonData:Object = {"imageUrl": imageUrl,
                                   "tagInfo" : tagInfo };
            
            var jsonParams:String = getEncodedJsonString( jsonData );
            
            var params:String = this.getParamString("uploadImageUrl", [["imageData", jsonParams]]);
            this.sendCommandData_ToServer(params, resultFunction);
        }

        protected function newReceiverForInitialize():SharedDataReceiver {
            return new SharedDataReceiver();
        }
        
        private var mentenanceCommands:Array = ["loginPassword", "getLoginInfo", "checkRoomStatus", "refresh"];
        
        private function isIgnoreCommand(commandName:String):Boolean {
            if( ! DodontoF_Main.getInstance().getMentenanceModeOn() ) {
                return false;
            }
            
            for(var i:int = 0 ; i < mentenanceCommands.length ; i++) {
                var mentenanceCommand:String = mentenanceCommands[i] as String;
                if( commandName == mentenanceCommand ) {
                    return false;
                }
            }
            
            return true;
        }
        
        protected function getParamString(commandName:String, params:Array):String {
            Log.logging("getParamString begin");
            
            if( isIgnoreCommand(commandName) ) {
                return null;
            }
            
            params.push(["Command", commandName]);
            params.push(["saveDataDirIndex", this.saveDataDirIndex]);
            
            if( isSampleMode() ) {
                params.push(["isSampleMode", true]);
            }
            
            Log.logging("paramString creating...");
            var paramString:String = new String();
            
            Log.logging("params analyzing ");
            for(var i:int = 0 ; i < params.length ; i++) {
                var param:Array = params[i] as Array;
                
                if( i != 0 ) {
                    paramString += "&";
                }
                
                paramString += param[0];
                paramString += "=";
                paramString += param[1];
            }
            
            Log.logging("getParamString paramString: " + paramString);
            
            return paramString;
        }
        
        public function startSessionRecording():void {
            var tmpTimes:Object = getInitLastUpdateTimes();
            tmpTimes.chatMessageDataLog = lastUpdateTimes.chatMessageDataLog;
            lastUpdateTimes = tmpTimes;
            receiver.startHistory();
        }
        
        public function clearLastUpdateTimes():void {
            lastUpdateTimes = getInitLastUpdateTimes();
        }
        
        private function getInitLastUpdateTimes():Object {
            var lastUpdateTimes:Object = {
                'map': 0,
                'characters': 0,
                'chatMessageDataLog': 0,
                'time': 0,
                'effects': 0
            };
            return lastUpdateTimes;
        }
        
        public function resetLastUpdateTimeOfInitiativeTimer():void {
            resetLastUpdateTime('time');
        }
        
        private function resetLastUpdateTime(type:String):void {
            lastUpdateTimes[type] = 0;
        }
        
        private function closeLoader(loader:URLLoader):void {
            try {
                loader.close();
            } catch( e:Error ) {
                Log.loggingExceptionDebug("SharedDataSender.closeLoader()", e);
            }
        }
        
        private function getUrlRequestForSendCommandData(paramsString:String):URLRequest {
            Log.logging("var request:URLRequest = new URLRequest();");
            var request:URLRequest = new URLRequest();
            request.url = Config.getInstance().getDodontoFServerCgiUrl();
            request.method = URLRequestMethod.POST;
            
            Log.logging("var variables:URLVariables = new URLVariables(paramsString);");
            var variables:URLVariables = new URLVariables(paramsString);
            request.data = variables;
            
            return request;
        }
        
        private function getUrlLoaderForSendCommand(callBack:Function):URLLoader {
            var loader:URLLoader = new URLLoader();
            
            var wrappedCallBack:Function = function(event:Event):void {
                if( callBack != null ) {
                    callBack.call(thisObj, event);
                }
                var oldLoader:URLLoader = URLLoader(event.target);
                closeLoader(oldLoader);
            }
            loader.addEventListener(Event.COMPLETE, wrappedCallBack);
            
            var wrappedCallBackForError:Function = function(event:Event):void {
                var oldLoader:URLLoader = URLLoader(event.target);
                closeLoader(oldLoader);
            }
            
            loader.addEventListener(IOErrorEvent.IO_ERROR, wrappedCallBackForError);
            loader.addEventListener(Event.UNLOAD, wrappedCallBackForError);
            
            return loader;
        }
        
        protected function sendCommandDataCatched(paramsString:String,
                                                  callBack:Function,
                                                  isRefresh:Boolean = false):void {
            if( paramsString == null ) {
                return;
            }
            
            var request:URLRequest = getUrlRequestForSendCommandData(paramsString);
            
            if( callBack == null ) {
                Log.loggingTuning("sendToURL begin");
                sendToURL(request);
                Log.loggingTuning("sendToURL end");
                return;
            }
            
            var loader:URLLoader = null;
            
            if( isRefresh ) {
                return;
            }
            
            loader = getUrlLoaderForSendCommand(callBack);
            
            loader.load(request);
            Log.logging("loader end");
        }
        
        public static function getJsonString(jsonData:Object):String {
            return Utils.getJsonString(jsonData);
        }
        
        public static function getEncodedJsonString(jsonData:Object):String {
            var jsonString:String = getJsonString(jsonData);
            Log.logging("jsonString", jsonString);
            
            var encodeJsonString:String =  encodeURIComponent(jsonString);
            Log.logging("encodeJsonString", encodeJsonString);
            
            return encodeJsonString;
        }
        
        public function getExistPiecesCount():int {
            return map.getExistPiecesCount();
        }
        
        public function removePlayRoom(roomNumber:int, resultFunction:Function, ignoreLoginUser:Boolean):void {
            Alert.show("removePlayRoom is NOT supported.")
        }
        
        public function addEffect(effectData:Object):void {
            addEffectData([effectData]);
        }
        
        private function addEffectData(effectDataList:Array):void {
            var effects:Array = getSaveData('effects') as Array;
            
            for(var i:int = 0 ; i < effectDataList.length ; i++) {
                var effectData:Object = effectDataList[i];
                effectData['effectId'] = createCharacterImgId("effects_");
                effects.push(effectData);
            }
            setSaveData('effects', effects);
        }
        
        public function changeEffect(effectData:Object):void {
            var effects:Array = getSaveData('effects') as Array;
            
            var targetId:String = effectData['effectId'];
            var index:int = -1;
            for(var i:int = 0 ; i < effects.length ; i++) {
                if( targetId == effects[i]['effectId'] ) {
                    index = i;
                    break;
                }
            }
            
            if( index == -1 ) {
                return;
            }
            
            effects[index] = effectData;
            setSaveData('effects', effects);
        }
        
        
        public function removeEffect(targetId:String):void {
            var effects:Array = getSaveData('effects') as Array;
            
            var index:int = -1;
            for(var i:int = 0 ; i < effects.length ; i++) {
                if( targetId == effects[i]['effectId'] ) {
                    index = i;
                }
            }
            
            if( index == -1 ) {
                return;
            }
            
            effects.splice(index, 1); 
            setSaveData('effects', effects);
        }
        
        public function changeImageTags(params_:Object):void {
            var jsonParams:String = getEncodedJsonString( params_ );
            var params:String = this.getParamString("changeImageTags", [["tagsData", jsonParams]]);
            this.sendCommandData_ToServer(params);
        }
        
        public function initCards(cardTypes:Array):void {
            var jsonData:Object = {
                "cardTypeInfos": cardTypes
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("initCards", [["initCardsData", jsonParams]]);
            this.sendCommandData(params);
        }
        
        public function clearCards():void {
            var jsonData:Object = {
                "types": [Card.getTypeStatic(), CardMount.getTypeStatic()]
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("clearCharacterByType", [["clearData", jsonParams]]);
            this.sendCommandData(params);
        }
        
        public function drawCard( isOpen:Boolean,
                                  owner:String,
                                  ownerName:String,
                                  mountName:String,
                                  x:int,
                                  y:int,
                                  id_:String ):void {
            var jsonData:Object = {
                "isOpen": isOpen,
                "mountName": mountName,
                "owner": owner,
                "ownerName":ownerName,
                "x": x,
                "y": y,
                "imgId": id_
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("drawCard", [["drawCardData", jsonParams]]);
            this.sendCommandData(params);
        }
        
        public function returnCard( mountName:String,
                                    x:int,
                                    y:int,
                                    id_:String ):void {
            var jsonData:Object = {
                "mountName": mountName,
                "x": x,
                "y": y,
                "imgId": id_
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("returnCard", [["data", jsonParams]]);
            this.sendCommandData(params);
        }
        
        
        public function shuffleCards( mountName:String, id_:String, isShuffle:Boolean ):void {
            var jsonData:Object = {
                "mountName": mountName,
                "imgId": id_,
                "isShuffle": isShuffle
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("shuffleCards", [["data", jsonParams]]);
            this.sendCommandData(params);
        }
        
        public function dumpTrushCard( targetCardId:String, mountName:String, id_:String ):void {
            var jsonData:Object = {
                "dumpedCardId": targetCardId,
                "mountName": mountName,
                "trushMountId": id_
            };
            var jsonParams:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("dumpTrushCards", [["data", jsonParams]]);
            this.sendCommandData(params);
        }
        
        public function addMessageCard(imageName:String, imageNameBack:String, x:int, y:int):void {
            var jsonData:Object = {
                "isText" : true,
                "imageName" : imageName,
                "imageNameBack" : imageNameBack,
                "mountName" : "messageCard",
                "isUpDown" : false,
                "canDelete" : true,
                "x" : x,
                "y" : y
            };
            var addCardData:String = getEncodedJsonString( jsonData );
            var params:String = this.getParamString("addCard", [["addCardData", addCardData]]);
            this.sendCommandData(params);
        }
        
    }
}
